/*  Comics Organizer Program
    Reports generation             */
    
#include <intuition/intuition.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <libraries/dos.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <libraries/reqtools.h>
#include <proto/reqtools.h>
#include "comics.h"

/* GADGET AND TEXT DEFINITIONS ------------------------------------- */

/*---------------------------------------------------*
  Gadgets created with PowerSource V3.0
  which is (c) Copyright 1990-91 by Jaba Development
  written by Jan van den Baard
 *---------------------------------------------------*/

extern struct Image RadioOn,RadioOff;

SHORT REPRenderBordersPairs0[] = {
  -1,-1,374,-1,374,124,-1,124,-1,-1 };
SHORT REPRenderBordersPairs1[] = {
  -1,-1,372,-1,372,123,-1,123,-1,-1 };
SHORT REPRenderBordersPairs2[] = {
  0,0,0,77,1,76,1,0,347,0 };
SHORT REPRenderBordersPairs3[] = {
  1,77,347,77,347,1,348,0,348,77 };

struct Border REPRenderBorders[] = {
  1,1,2,0,JAM1,5,(SHORT *)&REPRenderBordersPairs0[0],&REPRenderBorders[1],
  1,1,2,0,JAM1,5,(SHORT *)&REPRenderBordersPairs1[0],&REPRenderBorders[2],
  11,5,2,0,JAM1,5,(SHORT *)&REPRenderBordersPairs2[0],&REPRenderBorders[3],
  11,5,1,0,JAM1,5,(SHORT *)&REPRenderBordersPairs3[0],NULL };

SHORT REPSharedBordersPairs0[] = {
  0,0,0,13,1,12,1,0,97,0 };
SHORT REPSharedBordersPairs1[] = {
  1,13,97,13,97,1,98,0,98,13 };
SHORT REPSharedBordersPairs2[] = {
  -2,-1,-2,10,-1,10,-1,-1,346,-1 };
SHORT REPSharedBordersPairs3[] = {
  -1,10,346,10,346,0,347,-1,347,10 };
SHORT REPSharedBordersPairs4[] = {
  0,0,0,13,1,12,1,0,123,0 };
SHORT REPSharedBordersPairs5[] = {
  1,13,123,13,123,1,124,0,124,13 };

struct Border REPSharedBorders[] = {
  0,0,1,0,JAM1,5,(SHORT *)&REPSharedBordersPairs0[0],&REPSharedBorders[1],
  0,0,2,0,JAM1,5,(SHORT *)&REPSharedBordersPairs1[0],NULL,
  0,0,2,0,JAM1,5,(SHORT *)&REPSharedBordersPairs2[0],&REPSharedBorders[3],
  0,0,1,0,JAM1,5,(SHORT *)&REPSharedBordersPairs3[0],NULL,
  0,0,1,0,JAM1,5,(SHORT *)&REPSharedBordersPairs4[0],&REPSharedBorders[5],
  0,0,2,0,JAM1,5,(SHORT *)&REPSharedBordersPairs5[0],NULL };

struct IntuiText REPRenderTexts[] = {
  1,1,JAM1,23,11,NULL,(UBYTE *)"Output:",&REPRenderTexts[1],
  1,1,JAM1,23,37,NULL,(UBYTE *)"Include:",NULL };

struct IntuiText REPScreenGad_text = {
  2,2,JAM1,21,0,NULL,(UBYTE *)"Screen",NULL };

#define REPScreenGad_ID    54

struct Gadget REPScreenGad = {
  NULL,103,11,13,8,
  GADGHIMAGE+GADGIMAGE+SELECTED,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPScreenGad_text,NULL,NULL,REPScreenGad_ID,NULL };

struct IntuiText REPCloseGad_text = {
  2,2,JAM1,13,3,NULL,(UBYTE *)"Close Window",NULL };

#define REPCloseGad_ID    53

struct Gadget REPCloseGad = {
  &REPScreenGad,123,104,125,14,
  GADGHCOMP,
  RELVERIFY+ENDGADGET,
  BOOLGADGET+REQGADGET,
  (APTR)&REPSharedBorders[4],NULL,
  &REPCloseGad_text,NULL,NULL,REPCloseGad_ID,NULL };

struct IntuiText REPClearGad_text = {
  2,1,JAM1,18,0,NULL,(UBYTE *)"Clear Window",NULL };

#define REPClearGad_ID    52

struct Gadget REPClearGad = {
  &REPCloseGad,207,21,13,8,
  GADGHIMAGE+GADGIMAGE+SELECTED,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPClearGad_text,NULL,NULL,REPClearGad_ID,NULL };

UBYTE REPStringGad_buf[100] = "Distribution String";

struct StringInfo REPStringGad_info = {
  (UBYTE *)&REPStringGad_buf[0],NULL,0,100,0,0,0,0,0,0,NULL,NULL,NULL };

#define REPStringGad_ID   51

struct Gadget REPStringGad = {
  &REPClearGad,13,89,346,10,
  GADGHCOMP,
  RELVERIFY+STRINGCENTER+ENDGADGET,
  STRGADGET+REQGADGET,
  (APTR)&REPSharedBorders[2],NULL,
  NULL,NULL,(APTR)&REPStringGad_info,REPStringGad_ID,NULL };

struct IntuiText REPFormGad_text = {
  2,1,JAM1,20,0,NULL,(UBYTE *)"Format",NULL };

#define REPFormGad_ID    50

struct Gadget REPFormGad = {
  &REPStringGad,208,57,13,8,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPFormGad_text,NULL,NULL,REPFormGad_ID,NULL };

struct IntuiText REPCondGad_text = {
  2,1,JAM1,20,0,NULL,(UBYTE *)"Condition",NULL };

#define REPCondGad_ID    49

struct Gadget REPCondGad = {
  &REPFormGad,208,47,13,8,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPCondGad_text,NULL,NULL,REPCondGad_ID,NULL };

struct IntuiText REPPubGad_text = {
  2,1,JAM1,20,0,NULL,(UBYTE *)"Publisher",NULL };

#define REPPubGad_ID    48

struct Gadget REPPubGad = {
  &REPCondGad,208,37,13,8,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPPubGad_text,NULL,NULL,REPPubGad_ID,NULL };

struct IntuiText REPNotesGad_text = {
  2,1,JAM1,22,0,NULL,(UBYTE *)"Notes",NULL };

#define REPNotesGad_ID    47

struct Gadget REPNotesGad = {
  &REPPubGad,104,67,13,8,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPNotesGad_text,NULL,NULL,REPNotesGad_ID,NULL };

struct IntuiText REPPriceGad_text = {
  2,1,JAM1,22,0,NULL,(UBYTE *)"Prices",NULL };

#define REPPriceGad_ID    46

struct Gadget REPPriceGad = {
  &REPNotesGad,104,57,13,8,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPPriceGad_text,NULL,NULL,REPPriceGad_ID,NULL };

struct IntuiText REPArtGad_text = {
  2,1,JAM1,22,0,NULL,(UBYTE *)"Artists",NULL };

#define REPArtGad_ID    45

struct Gadget REPArtGad = {
  &REPPriceGad,104,47,13,8,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPArtGad_text,NULL,NULL,REPArtGad_ID,NULL };

struct IntuiText REPDateGad_text = {
  2,1,JAM1,22,0,NULL,(UBYTE *)"Date",NULL };

#define REPDateGad_ID    44

struct Gadget REPDateGad = {
  &REPArtGad,104,37,13,8,
  GADGHIMAGE+GADGIMAGE+SELECTED,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPDateGad_text,NULL,NULL,REPDateGad_ID,NULL };

struct IntuiText REPTitleGad_text = {
  2,1,JAM1,19,0,NULL,(UBYTE *)"Report Title",NULL };

#define REPTitleGad_ID    43

struct Gadget REPTitleGad = {
  &REPDateGad,207,11,13,8,
  GADGHIMAGE+GADGIMAGE+SELECTED,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPTitleGad_text,NULL,NULL,REPTitleGad_ID,NULL };

struct IntuiText REPDiskGad_text = {
  2,1,JAM1,21,0,NULL,(UBYTE *)"Disk",NULL };

#define REPDiskGad_ID    42

struct Gadget REPDiskGad = {
  &REPTitleGad,104,21,13,8,
  GADGHIMAGE+GADGIMAGE+SELECTED,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  &REPDiskGad_text,NULL,NULL,REPDiskGad_ID,NULL };

struct IntuiText REPCancelGad_text = {
  2,1,JAM1,26,3,NULL,(UBYTE *)"Cancel",NULL };

#define REPCancelGad_ID    41

struct Gadget REPCancelGad = {
  &REPDiskGad,262,104,99,14,
  GADGHCOMP,
  RELVERIFY+ENDGADGET,
  BOOLGADGET+REQGADGET,
  (APTR)&REPSharedBorders[0],NULL,
  &REPCancelGad_text,NULL,NULL,REPCancelGad_ID,NULL };

struct IntuiText REPOKGad_text = {
  2,1,JAM1,18,3,NULL,(UBYTE *)"Generate",NULL };

#define REPOKGad_ID    40

struct Gadget REPOKGad = {
  &REPCancelGad,12,104,99,14,
  GADGHCOMP,
  RELVERIFY+ENDGADGET,
  BOOLGADGET+REQGADGET,
  (APTR)&REPSharedBorders[0],NULL,
  &REPOKGad_text,NULL,NULL,REPOKGad_ID,NULL };

struct Requester REPRequester = {
  NULL,45,8,376,126,0,0,
  &REPOKGad,&REPRenderBorders[0],&REPRenderTexts[0],
  NULL,0,NULL,NULL,NULL,NULL,NULL };


/*  GLOBAL VARIABLES -------------------------------------- */

#define REPSCREEN 1    /*  Used to select output modes  */
#define REPDISK   2
#define REPTITLE  4
#define REPCLEAR  8

#define INCDATE   1    /*  Used to select which fields to include */
#define INCART    2
#define INCPRICE  4
#define INCNOTES  8
#define INCPUB    16
#define INCCOND   32
#define INCFORM   64

USHORT MainGads = REPSCREEN+REPDISK+REPTITLE+REPCLEAR;
USHORT IncGads = INCDATE;
char reportstring[150];
FILE *Consoleptr = 0L;

extern struct Window *MainWindow;
extern struct Screen *ComicScreen;
extern ComicNodePtr head,current;
extern struct ComicFile Comics;
extern char newfilename[108],newpathname[108],wholefilename[216];
extern FILE *Fileptr;
extern struct IntuiText SubItemsText[];
extern BOOL exactmatch;

/*  FUNCTION PROTOTYPES ----------------------------------- */

void DoReport(USHORT,USHORT);
void AllIss(),MissingIss();
void TotalReport();
void DistribReport(USHORT),SearchReport(USHORT);
void RankedReport(USHORT);
void Sort(ComicNodePtr *,USHORT);
void OutputStr(char *);
void OutputComic(ComicNodePtr);

extern BOOL GetFileName(char *);
extern void ConvertStr(char *),SaveComic();
extern BOOL CompareStrings(char *,char *,BOOL);
extern BOOL makeIcon(char *,char **,char *,BOOL);


/*  MAIN REQUESTER ROUTINE -------------------------------- */

void DoReport(MenuItem,SubItem)
USHORT MenuItem,SubItem;
{
	ULONG class;
	USHORT GadgetID;
	struct Gadget *GadgetPtr;
	BOOL itworked = FALSE;
	BOOL closerequester = FALSE;
	struct IntuiMessage *reqmessage;
	
	if (Comics.Changed) SaveComic();
	if (current == NULL) return;   /* Make sure at least 1 entry exists */
	
	/*  Turn off "include" gadgets for Missing Issues, Totals, and
	    Distribution reports  */
	if ( (MenuItem == 1) || (MenuItem == 3) || 
	     ((MenuItem == 7) && (SubItem <3)) )
	{
		OffGadget(&REPDateGad,MainWindow,&REPRequester);
		OffGadget(&REPArtGad,MainWindow,&REPRequester);
		OffGadget(&REPPriceGad,MainWindow,&REPRequester);
		OffGadget(&REPNotesGad,MainWindow,&REPRequester);
		OffGadget(&REPPubGad,MainWindow,&REPRequester);
		OffGadget(&REPCondGad,MainWindow,&REPRequester);
		OffGadget(&REPFormGad,MainWindow,&REPRequester);
	}
	
	/*  Turn off string gadget unless is a distribution search */
	if ( (MenuItem == 7) && (SubItem > 2) ) 
		OnGadget(&REPStringGad,MainWindow,&REPRequester);
	else
		OffGadget(&REPStringGad,MainWindow,&REPRequester);
		
	itworked = Request(&REPRequester,MainWindow);
	
	if (!itworked)
	{
		SetWindowTitles(MainWindow,-1,"Cannot open report requester!");
		return;
	}
	
	while (!closerequester)
	{
		if ((reqmessage = (struct IntuiMessage *)
		     GetMsg(MainWindow->UserPort)) == NULL)
		{
			Wait(1L << MainWindow->UserPort->mp_SigBit);
			continue;
		}
		
		class = reqmessage->Class;
		GadgetPtr = (struct Gadget *) reqmessage->IAddress;
		GadgetID = GadgetPtr->GadgetID;
		ReplyMsg((struct Message *) reqmessage);
		
		if (class & GADGETUP)
		    switch (GadgetID)
		    {
			case REPOKGad_ID     : closerequester = TRUE;
			                       itworked = TRUE;
					       break;
		        case REPCancelGad_ID : closerequester = TRUE;
			                       itworked = FALSE;
					       break;
			case REPCloseGad_ID  : closerequester = TRUE;
					       itworked = FALSE;
					       if (Consoleptr) fclose(Consoleptr);
					       Consoleptr = 0L;
					       break;
			case REPStringGad_ID : closerequester = TRUE;
					       itworked = TRUE;
					       break;
			case REPScreenGad_ID : MainGads ^= REPSCREEN;
					       break;
			case REPDiskGad_ID   : MainGads ^= REPDISK;
					       break;
			case REPTitleGad_ID  : MainGads ^= REPTITLE;
					       break;
			case REPClearGad_ID  : MainGads ^= REPCLEAR;
					       break;
			case REPDateGad_ID   : IncGads ^= INCDATE;
					       break;
			case REPArtGad_ID    : IncGads ^= INCART;
					       break;
			case REPPriceGad_ID  : IncGads ^= INCPRICE;
					       break;
			case REPNotesGad_ID  : IncGads ^= INCNOTES;
					       break;
			case REPPubGad_ID    : IncGads ^= INCPUB;
					       break;
			case REPCondGad_ID   : IncGads ^= INCCOND;
					       break;
			case REPFormGad_ID   : IncGads ^= INCFORM;
					       break;
		    }
		if (class & REQCLEAR)	closerequester = TRUE;
	}

	/* Turn Gadgets back on */
	if ((MenuItem == 1) || (MenuItem == 3) ||
	    ((MenuItem == 7) && (SubItem < 3)) )
	{
		OnGadget(&REPDateGad,MainWindow,&REPRequester);
		OnGadget(&REPArtGad,MainWindow,&REPRequester);
		OnGadget(&REPPriceGad,MainWindow,&REPRequester);
		OnGadget(&REPNotesGad,MainWindow,&REPRequester);
		OnGadget(&REPPubGad,MainWindow,&REPRequester);
		OnGadget(&REPCondGad,MainWindow,&REPRequester);
		OnGadget(&REPFormGad,MainWindow,&REPRequester);
	}
	
	EndRequest(&REPRequester,MainWindow);
	
	
	if (itworked)
	{
		if ( ((MainGads & REPDISK) == 0) &&
		     ((MainGads & REPSCREEN) == 0) )
		{
			/* No output mode was selected */
			return;
		}
		
		/*  Get the title of the report file name */
		Fileptr = 0L;
		if (MainGads & REPDISK)
		{
			strcpy (newfilename,Comics.Reportfile);
			strcpy (newpathname,Comics.FilePath);
			GetFileName("Report file:");
			strcpy (Comics.Reportfile,newfilename);
			strcpy (wholefilename,newpathname);
			strcat (wholefilename,newfilename);
		
			if (!(Fileptr = fopen(wholefilename,"a")))
			{
				rtEZRequest("Can't open file!","Abort",NULL,NULL);
			}
		}
		
		/*  Open console output window  */
		if (MainGads & REPSCREEN)
		{
			if (MainGads & REPCLEAR)
			/*  Close the console window  */
			{	if (Consoleptr)	fclose(Consoleptr);
				Consoleptr = 0L;	}
			
			if (!Consoleptr)  /* Open console if it's not */
			{
				Consoleptr = fopen("CON:0/0/640/200/Reports","r+");
				if (!Consoleptr) rtEZRequest("Can't open reports window!","Abort",NULL,NULL);
				else	WBenchToFront();
			}
			else
				WBenchToFront();
		}
				
		if ( (Consoleptr == 0L) && (Fileptr == 0L) ) return;
		
		switch (MenuItem)
		{
		    case 0  : AllIss();         /* All issues */
		    	      break;
		    case 1  : MissingIss();     /* Missing issues of */
		              break;            /*  current title    */
		    case 3  : TotalReport();    /* Totals... */
		    	      break;
		    case 4  : RankedReport(0);  /* Most Valuable */
			      break;
		    case 5  : RankedReport(1);  /* Most Profitable */
		    	      break;
		    case 6  : RankedReport(2);  /* Oldest */
		    	      break;
		    case 7  : /*  Distributions by Publisher,Condition,etc*/
		    	      if (SubItem < 3) DistribReport(SubItem);
		    	      /*  Distribution by artist or notes */
			      else	       SearchReport((USHORT) (SubItem-3));
			      break;
		}
		
		if (Fileptr != 0L)
		{	fclose(Fileptr);
			/*  Write the Icon for the reports file.  Add
			   the name of the text editor you use most often
			   to replace the second NULL. */
			makeIcon(wholefilename,NULL,NULL,TRUE);
		}
		if (Consoleptr != 0L)
		{	Delay(200L);  /*leave reports window open*/
			ScreenToFront(ComicScreen);
			ActivateWindow(MainWindow);	}
	}
}


/*  REPORTS GENERATION ------------------------------------ */

void AllIss()
{
	register ComicNodePtr cur;
	char curtitle[TITLELEN],testtitle[TITLELEN];
		
	/*  If "Title" Radio Button was on, output report title */
	sprintf(reportstring,"%s : %d issues\n",Comics.FileName,Comics.TotalIssues);	
	if (MainGads & REPTITLE) OutputStr(reportstring);
	
	cur = head;
	while (cur != NULL)
	{
		strcpy (testtitle,cur->Title);
		strcpy (curtitle,testtitle);
		ConvertStr(testtitle);
		
		sprintf(reportstring,"%s:\n\n",curtitle);
		OutputStr(reportstring);
		ConvertStr(curtitle);
		
		while( (strcmp(curtitle,testtitle) == 0) && (cur !=NULL)) 
		{
			OutputComic(cur);
			cur = cur->next;
			if (cur)
			{	strcpy(curtitle,cur->Title);
				ConvertStr(curtitle);		}
		}
		OutputStr("\n\n");
	}
}

void MissingIss()
{
	register ComicNodePtr cur,startptr,endptr;
	char curtitle[TITLELEN],testtitle[TITLELEN];
	int startissue,endissue,i,missingnum;
	long startlong,endlong;
	BOOL success;
		
	/*  If "Title" Radio Button was on, output report title */
	sprintf(reportstring,"Missing Issues of %s\n",current->Title);	
	if (MainGads & REPTITLE) OutputStr(reportstring);
	
	/*  Find first issue of this title  */
	strcpy (testtitle,current->Title);
	ConvertStr(testtitle);
	strcpy (curtitle,testtitle);
	cur = current;
	
	while ( (cur->prev != NULL) && (strcmp (curtitle,testtitle) == 0) )
	{
		cur = cur->prev;
		strcpy (curtitle,cur->Title);
		ConvertStr(curtitle);
	}
	if (cur->prev == NULL)	startptr = cur;
	else			startptr = cur->next;
		
	/*  Find last issue of this title  */
	cur = startptr;
	strcpy (curtitle,testtitle);
	
	while ((cur->next != NULL) && (strcmp (curtitle,testtitle) == 0) )
	{
		cur = cur->next;
		strcpy (curtitle,cur->Title);
		ConvertStr(curtitle);
	}
	if (cur->next == NULL)	endptr = cur;
	else			endptr = cur->prev;
	
	/*  Get user's starting and ending issues  */
	startlong = (long) startptr->Issue;
	endlong = (long) endptr->Issue;
	
	if (!rtGetLong(&startlong,"Starting issue #",NULL,
		       RTGL_Min,1L,RTGL_Max,endlong))   return;
	if (!rtGetLong(&endlong,"Ending issue #",NULL,
		       RTGL_Min,startlong,RTGL_Max,1000)) return;
	
	startissue = (int) startlong;
	endissue = (int) endlong;
	
	/*  Perform search for missing issues  */
	missingnum = 0;   /* total # of issues missing */
	cur = startptr;
	success = FALSE;
	
	for (i = startissue;i <= endissue;i++)
	{
		while ( (cur->Issue < i) && (cur != endptr) )
			cur = cur->next;
		
		if (cur->Issue != i)   /* is missing */
		{
			if (success)	OutputStr(", ");
			sprintf(reportstring,"%d",i);
			OutputStr(reportstring);
			success = TRUE; 
			missingnum++;
		}
		else	cur = cur->next;
	}
	if (!success)
		strcpy(reportstring,"No issues missing!\n\n");
	else
		sprintf(reportstring,"\n%d issues missing.\n\n",missingnum);
		
	OutputStr(reportstring);
}

void TotalReport()
/*  Reports total cost of collection, value of collection, profit in
    collection, number of issues and titles  */
{
	char curtitle[TITLELEN],testtitle[TITLELEN];
	register ComicNodePtr cur;
	int numoftitles = 1;
	float totalcost = 0.0,totalvalue = 0.0,totalprofit = 0.0;
	
	sprintf(reportstring,
	        "Totals for %s\n----------------------------\n\n",
		Comics.FileName);
	if (MainGads & REPTITLE)	OutputStr(reportstring);
	
	sprintf(reportstring,"%d issues.\n",Comics.TotalIssues);
	OutputStr(reportstring);
	
	cur = head;
	strcpy (testtitle,cur->Title);
	ConvertStr(testtitle);
	
	while (cur != NULL)
	{
		strcpy (curtitle,cur->Title);
		ConvertStr(curtitle);
		if (strcmp(curtitle,testtitle) != 0)   /*  New Title  */
		{
			numoftitles++;
			strcpy(testtitle,curtitle);
		}
		
		totalcost += (cur->Purchase * cur->Copies);
		totalvalue += (cur->Current * cur->Copies);
		totalprofit += (cur->Profit * cur->Copies);
		cur = cur->next;
	}
	
	sprintf(reportstring,"%d titles.\n\n",numoftitles);
	OutputStr(reportstring);
	
	sprintf(reportstring,"Total Cost:           $ %5.2f\n",totalcost);
	OutputStr(reportstring);
	sprintf(reportstring,"Total Current Value:  $ %5.2f\n",totalvalue);
	OutputStr(reportstring);
	sprintf(reportstring,"Total Profit:         $ %5.2f\n\n",totalprofit);
	OutputStr(reportstring);
}

void SearchReport(SubItem)
USHORT SubItem;
{
	register ComicNodePtr cur;
	char teststring[NOTESLEN],curtitle[TITLELEN];
	int issuesfound = 0;
	
	sprintf (reportstring,"Appearances of '%s'",REPStringGad_buf);
	if (MainGads & REPTITLE)
	{	OutputStr(reportstring);
		OutputStr("\n----------------------------------\n");  }
	
	ConvertStr(REPStringGad_buf);
	for (cur = head; cur != NULL; cur = cur->next)
	{
		switch(SubItem)
		{
			case 0 : strcpy(teststring,cur->Artist);
				 break;
			case 1 : strcpy(teststring,cur->Notes);
				 break;
		}
		if (CompareStrings(teststring,REPStringGad_buf,FALSE))
		{	if (strcmp (curtitle,cur->Title) != 0)
			{	sprintf(reportstring,"\n%s\n",cur->Title);
				OutputStr(reportstring);
				strcpy (curtitle,cur->Title);	}
			OutputComic(cur);
			issuesfound++;		}
	}
	
	OutputStr("--------------------------------------\n");
	sprintf(reportstring,"%d appearances found.\n\n",issuesfound);
	OutputStr(reportstring);
}

void DistribReport(SubItem)
USHORT SubItem;
{
	register ComicNodePtr cur;
	int startindex,endindex;
	int values[7] = { 0,0,0,0,0,0,0 };
	char teststring[16];
	register int i;
	BOOL success;
	
	strcpy (reportstring,"Distribution by ");
	switch (SubItem)
	{
		case 0 : strcat (reportstring,"Publisher:");
		         startindex = 0;
			 endindex = 6;
			 break;
	        case 1 : strcat (reportstring,"Condition:");
		         startindex = 7;
			 endindex = 13;
			 break;
	        case 2 : strcat (reportstring,"Format:");
		         startindex = 14;
			 endindex = 19;
			 break;
	}
	if (MainGads & REPTITLE)
	{	OutputStr(reportstring);
		OutputStr("\n-------------------------------------\n\n"); }
	
	/*  Initialize values array  */
	for (i = 0;i < 8;i++)
		values[i] = 0;
		
	/*  Go through list, matching with possible names  */
	for (cur = head;cur != NULL;cur=cur->next)
	{
		switch(SubItem)
		{
			case 0 : strcpy (teststring,cur->Publisher);
			         break;
		        case 1 : strcpy (teststring,cur->Condition);
			         break;
			case 2 : strcpy (teststring,cur->Format);
			         break;
		}
		success = FALSE;
		for (i = startindex;(i <= endindex) && (success == FALSE);i++)
		{
		    if (strcmp(teststring,SubItemsText[i].IText + 2) == 0) 
		    { /*  There is a match.  (Truncate 2 leading spaces for
                        the checkmark.  */
		    	values[i-startindex]++;
			success = TRUE;
		    }
		}
		/* If no match found, increment "others" */
		if (success == FALSE)	values[endindex-startindex+1]++;
	}
	
	for (i = startindex; i <= endindex; i++)
	{
		sprintf(reportstring,
			"  %s : %d\n",
			SubItemsText[i].IText,values[i-startindex]);
		OutputStr(reportstring);
	}
	sprintf(reportstring,"    Others      : %d\n\n",
	        values[endindex-startindex+1]);
	OutputStr(reportstring);
}

void RankedReport(SubItem)
USHORT SubItem;
{
	register ComicNodePtr cur;
	ComicNodePtr thelist[20];
	register int i;
	int curdate,thedate;

	cur = head;
	for (i = 0; i < 20;i++)
	{
		thelist[i] = cur;
		if (cur != NULL)	cur = cur->next;
	}
	Sort(thelist,SubItem);
	
	for (;cur != NULL;cur = cur->next)
	{
		switch(SubItem)
		{
			case 0 : if (cur->Current > thelist[0]->Current)
				 {	thelist[19] = cur;
					Sort(thelist,SubItem);	}
				 break;
			case 1 : if (cur->Profit > thelist[0]->Profit)
				 {	thelist[19] = cur;
					Sort(thelist,SubItem);	}
				 break;
			case 2 : thedate = atoi(thelist[0]->Date + 4);
				 curdate = atoi(cur->Date + 4);
				 if (curdate < thedate)
				 {	thelist[19] = cur;
					Sort(thelist,SubItem);	}
				 break;
		}
	}
	
	if (MainGads & REPTITLE)
	{	switch (SubItem)
		{
		    case 0 : OutputStr("Most Valuable Comics");
			     break;
		    case 1 : OutputStr("Most Profitable Comics");
		             break;
		    case 2 : OutputStr("Oldest Comics");
		             break;
		}
		OutputStr("\n---------------------------------------\n");
	}
	
	for (i = 0;i < 20;i++)
	{	OutputStr(thelist[i]->Title);
		OutputStr(",");
		OutputComic(thelist[i]);	}
	OutputStr("\n");
}

void Sort(thelist,SubItem)
ComicNodePtr *thelist;
USHORT SubItem;
/*  A SLOW exchange sort, but it should be fairly fast since the
    list will most often be almost sorted   */
{
	int curdate,thedate,i;
	BOOL switched = TRUE,switchem = FALSE;
	ComicNodePtr temp;
	
	while (switched == TRUE)
	{	switched = FALSE;
		for (i=0;i < 19;i++)
		{	
		    switchem = FALSE;
		    switch(SubItem)
		    {
			case 0 : if (thelist[i]->Current <
			             thelist[i+1]->Current) switchem = TRUE;
				 break;
			case 1 : if (thelist[i]->Profit <
				     thelist[i+1]->Profit) switchem = TRUE;
				 break;
			case 2 : thedate = atoi(thelist[i]->Date + 4);
				 curdate = atoi(thelist[i+1]->Date + 4);
				 if (curdate < thedate) switchem = TRUE;
				 break;
		    }
		    /*  Exchange them if switchem = TRUE  */
		    if (switchem)
		    {	switched = TRUE;
			temp = thelist[i+1];
			thelist[i+1] = thelist[i];
			thelist[i] = temp;	}
		}
	}
}		 

/*  OUTPUT ROUTINES --------------------------------------------- */

void OutputStr(thestring)
char *thestring;
{
	if ( (MainGads & REPDISK) && (Fileptr != 0L) )
	{
		fprintf(Fileptr,"%s",thestring);
	}
	
	if ( (MainGads & REPSCREEN) && (Consoleptr != 0L) )
	{
		fprintf(Consoleptr,"%s",thestring);
	}
}

void OutputComic(comicptr)
ComicNodePtr comicptr;
{
	char *formatstr = ", %s";
	
	sprintf(reportstring,"%d",comicptr->Issue);
	OutputStr(reportstring);
	
	if (IncGads & INCDATE)
	{
		sprintf(reportstring,formatstr,comicptr->Date);
		OutputStr(reportstring);
	}
	if (IncGads & INCART)
	{
		sprintf(reportstring,formatstr,comicptr->Artist);
		OutputStr(reportstring);
	}
	if (IncGads & INCPRICE)
	{
		sprintf(reportstring,",COV: $ %3.2f,PUR: $ %3.2f,CUR: $ %3.2f,PRO: $ %3.2f",
			comicptr->Cover,comicptr->Purchase,
			comicptr->Current,comicptr->Profit);
		OutputStr(reportstring);
	}
	if (IncGads & INCNOTES)
	{
		sprintf(reportstring,formatstr,comicptr->Notes);
		OutputStr(reportstring);
	}
	if (IncGads & INCCOND)
	{
		sprintf(reportstring,formatstr,comicptr->Condition);
		OutputStr(reportstring);
	}
	if (IncGads & INCPUB)
	{
		sprintf(reportstring,formatstr,comicptr->Publisher);
		OutputStr(reportstring);
	}
	if (IncGads & INCFORM)
	{
		sprintf(reportstring,formatstr,comicptr->Format);
		OutputStr(reportstring);
	}
	if (IncGads)
		OutputStr("\n");   /* Print a newline if other fields printed */
	else
		OutputStr(",");    /* If only issues, just print a comma */
}
